<link rel="stylesheet" href="Field.scss">
<template>
  <form action="#">
    <rui-form-errors :errors="errors"
                     :model="model" />

    <div class="_container">
      <slot />
    </div>

    <rui-actions bottom>
      <rui-button v-if="cancellable"
                  type="reset"
                  variant="canceling"
                  :disabled="loading"
                  @click="$emit('cancel')">
        {{ $t('rui.generic.cancel') }}
      </rui-button>
      <rui-submit-button :loading="loading" :caption="submitButtonTitle" :icon="submitButtonIcon" :disabled="disableSubmit" />
    </rui-actions>
  </form>
</template>

<script>
import RuiSubmitButton from '../Inputs/SubmitButton/SubmitButton.vue'
import RuiFormErrors from './FormErrors.vue'
import RuiButton from '../Button/Button.vue'
import RuiActions from '../Actions/Actions.vue'

/**
 * Simple form with submit/cancel actions
 *
 * @preset default {
 *                    "props": { "errors": {"error": "Simple error message" } },
 *                    "slots": { "default": "Form inputs content goes here" }
 *                 }
 * @preset complex_error {
 *                    "props": { "errors": { "title": ["is missing"], "content": ["is boring", "is not long enough"] } },
 *                    "slots": { "default": "Form inputs content goes here" }
 *                  }
 */
export default {
  name: 'RuiForm',
  emits: [
    'cancel',
  ],
  components: { RuiActions, RuiButton, RuiFormErrors, RuiSubmitButton },
  props: {
    /** Model name to display errors */
    model: { required: false, type: String, default: null },
    /** Whether something is loading */
    loading: { required: false, type: Boolean, default: false },
    /** Errors list */
    errors: { required: false, type: Object, default: null },
    /** Custom caption for the submit button */
    submitButtonTitle: { required: false, type: String, default: null },
    /** Whether to disable the submit button (e.g.: in case of form error) */
    disableSubmit: { required: false, type: Boolean, default: false },
    /** Custom icon for the submit button */
    submitButtonIcon: { required: false, type: String, default: null },
    /** Whether to display a "Cancel" button */
    cancellable: { required: false, type: Boolean, default: true },
  },
}
</script>
